#include "StdAfx.h"
#include "DbEmployeeList.h"
#include "Oxetta.h"
#include "MemEmployeeList.h"
#include "CsvFile.h"
#include "..\HelperFunctions.h"

BOOL DbEmployeeList(CString &sError)
{
//  loading reporting library
	HMODULE hDll = LoadLibrary(GetStartDir() + _T("\\oxetta.dll"));
	if (NULL == hDll)
	{
		sError = _T("Failed to load reporting engine DLL");
		return FALSE;
	}

//  getting a pointer to the print preview function
#ifdef _UNICODE
	COxiPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewW");
#else
	COxiPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewA");
#endif
	if (NULL == pfnPreview)
	{
		FreeLibrary(hDll);
		hDll = NULL;
		sError = _T("Failed to get a pointer to a function in the reporting engine DLL");
		return FALSE;
	}

//  assembling the report file path string
	TCHAR szReport[MAX_PATH];
	_tcscpy(szReport, GetStartDir());
	_tcscat(szReport, _T("\\dbEmployeeList.oxi"));

//  printing the report
	TCHAR szError[1024];
	BOOL bResult = pfnPreview(szReport, (COxiCallback)NULL, NULL, szError);
	
//  cleaning up and exiting
	pfnPreview = NULL;
	FreeLibrary(hDll);
	hDll = NULL;
	sError = szError;
	return bResult;
}
