#include "StdAfx.h"
#include "MemBusinessCard.h"
#include "..\HelperFunctions.h"
#include "Oxetta.h"

int PASCAL _stdcall BusniessCardCallback(TCHAR *szBand, TCHAR *szName, TCHAR *szValue, void **ppParam)
{
//  creating a static variable that will help us print the report only once
	static BOOL bPrint = FALSE;
	if (NULL == szName)
	{
		bPrint = !bPrint;
		if (!bPrint)
		{
			bPrint = TRUE;
			return FALSE;
		}
	}
	else
	if (0 == _tcsicmp(szName, _T("Company")))
		_tcscpy(szValue, _T("Parts&&Machines, LLC"));
	else
	if (0 == _tcsicmp(szName, _T("Name")))
		_tcscpy(szValue, _T("James Smith"));
	else
	if (0 == _tcsicmp(szName, _T("Position")))
		_tcscpy(szValue, _T("Manager Of Auditing"));
	else
	if (0 == _tcsicmp(szName, _T("email")))
		_tcscpy(szValue, _T("JSmith@machines.com"));
	else
	if (0 == _tcsicmp(szName, _T("Telephone")))
		_tcscpy(szValue, _T("1-123-456-6789"));
	else
	if (0 == _tcsicmp(szName, _T("Address")))
		_tcscpy(szValue, _T("31332 West Street, #87, Westlake, CA"));

	return TRUE;
}


BOOL MemBusinessCard(CString &sError)
{
//  loading reporting library
	HMODULE hDll = LoadLibrary(GetStartDir() + _T("\\oxetta.dll"));
	if (NULL == hDll)
	{
		sError = _T("Failed to load reporting engine DLL");
		return FALSE;
	}

//  getting a pointer to the print preview function
#ifdef _UNICODE
	COxiPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewW");
#else
	COxiPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewA");
#endif
	if (NULL == pfnPreview)
	{
		FreeLibrary(hDll);
		hDll = NULL;
		sError = _T("Failed to get a pointer to a function in the reporting engine DLL");
		return FALSE;
	}

//  assembling the report file path string
	TCHAR szReport[MAX_PATH];
	_tcscpy(szReport, GetStartDir());
	_tcscat(szReport, _T("\\memBusinessCard.oxi"));

//  printing the report
	TCHAR szError[1024];
	ZeroMemory(szError, 1024 * sizeof(TCHAR));
	BOOL bResult = pfnPreview(szReport, BusniessCardCallback, NULL, szError);
	
//  cleaning up and exiting
	pfnPreview = NULL;
	FreeLibrary(hDll);
	hDll = NULL;
	sError = szError;
	return bResult;
}
