#include "StdAfx.h"
#include "dbBusinessCard.h"
#include "Oxetta.h"
#include "MemEmployeeList.h"
#include "CsvFile.h"
#include "..\HelperFunctions.h"
#include "..\PersonDlg.h"

int PASCAL _stdcall dbBusniessCardCallback(TCHAR *szBand, TCHAR *szName, TCHAR *szValue, void **ppParam)
{
	ASSERT(ppParam);
	ASSERT(*ppParam);
	if (0 == _tcsicmp(szName, _T("employee_id")))
		_tcscpy(szValue, (TCHAR*)ppParam);
	return TRUE;
}

BOOL DbBusinessCard(CString &sError)
{
//  choosing the person to print
	TCHAR szPersonID[10];
	CPersonDlg dlg;
	if (IDOK != dlg.DoModal())
		return TRUE;
	else
		_stprintf((TCHAR*)szPersonID, _T("%d"), dlg.m_iSelectedID);

//  loading reporting library
	HMODULE hDll = LoadLibrary(GetStartDir() + _T("\\oxetta.dll"));
	if (NULL == hDll)
	{
		sError = _T("Failed to load reporting engine DLL");
		return FALSE;
	}

//  getting a pointer to the print preview function
#ifdef _UNICODE
	COxiPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewW");
#else
	CPreview pfnPreview = (COxiPreview)GetProcAddress(hDll, "oxiPreviewA");
#endif
	if (NULL == pfnPreview)
	{
		FreeLibrary(hDll);
		hDll = NULL;
		sError = _T("Failed to get a pointer to a function in the reporting engine DLL");
		return FALSE;
	}

//  assembling the report file path string
	TCHAR szReport[MAX_PATH];
	_tcscpy(szReport, GetStartDir());
	_tcscat(szReport, _T("\\dbBusinessCard.oxi"));

//  printing the report
	TCHAR szError[1024];
	BOOL bResult = pfnPreview(szReport, dbBusniessCardCallback, (void**)&szPersonID, szError);
	
//  cleaning up and exiting
	pfnPreview = NULL;
	FreeLibrary(hDll);
	hDll = NULL;
	sError = szError;
	return bResult;
}
